org.h2.value

## Class ValueArray

- java.lang.Object
- - org.h2.value.VersionedValue
  - - org.h2.value.Value
    - - org.h2.value.ValueCollectionBase
      - - org.h2.value.ValueArray

    public class ValueArray
    extends ValueCollectionBase

Implementation of the ARRAY data type.

### Field Summary

### Fields inherited from class org.h2.value.Value

`ARRAY, BLOB, BOOLEAN, BYTE, BYTES, CLOB, DATE, DECIMAL, DOUBLE, ENUM, FLOAT, GEOMETRY, INT, INTERVAL_DAY, INTERVAL_DAY_TO_HOUR, INTERVAL_DAY_TO_MINUTE, INTERVAL_DAY_TO_SECOND, INTERVAL_HOUR, INTERVAL_HOUR_TO_MINUTE, INTERVAL_HOUR_TO_SECOND, INTERVAL_MINUTE, INTERVAL_MINUTE_TO_SECOND, INTERVAL_MONTH, INTERVAL_SECOND, INTERVAL_YEAR, INTERVAL_YEAR_TO_MONTH, JAVA_OBJECT, LONG, MIN_LONG_DECIMAL, NULL, RESULT_SET, ROW, SHORT, STRING, STRING_FIXED, STRING_IGNORECASE, TIME, TIMESTAMP, TIMESTAMP_TZ, TYPE_COUNT, UNKNOWN, UUID`

### Fields inherited from class org.h2.value.VersionedValue

`DUMMY`

### Method Summary

Methods
`int` `compareTypeSafe(Value o, CompareMode mode)` Compare this value against another value given that the values are of the same data type.
`Value` `convertPrecision(long precision, boolean force)` Convert the precision to the requested value.
`boolean` `equals(java.lang.Object other)` Check if the two values have the same hash code.
`static ValueArray` `get(java.lang.Class<?> componentType, Value[] list)` Get or create a array value for the given value array.
`static ValueArray` `get(Value[] list)` Get or create a array value for the given value array.
`java.lang.Class<?>` `getComponentType()`
`static ValueArray` `getEmpty()` Returns empty array.
`java.lang.Object` `getObject()` Get the value as an object.
`java.lang.StringBuilder` `getSQL(java.lang.StringBuilder builder)` Appends the SQL expression for this value to the specified builder.
`java.lang.String` `getString()` Get the value as a string.
`java.lang.String` `getTraceSQL()` Get a medium size SQL expression for debugging or tracing.
`int` `getValueType()` Get the value type.
`void` `set(java.sql.PreparedStatement prep, int parameterIndex)` Set the value as a parameter in a prepared statement.

### Methods inherited from class org.h2.value.ValueCollectionBase

`compareWithNull, containsNull, getList, getMemory, getType, hashCode`

### Methods inherited from class org.h2.value.Value

`add, checkPrecision, clearCache, compareTo, convertScale, convertTo, convertTo, convertTo, convertTo, convertToInt, copy, copyToResult, copyToTemp, divide, getBigDecimal, getBoolean, getByte, getBytes, getBytesNoCopy, getDataHandler, getDate, getDouble, getFloat, getHigherOrder, getHigherType, getInputStream, getInputStream, getInt, getLong, getReader, getReader, getResult, getShort, getSignum, getSmall, getSQL, getTableId, getTime, getTimestamp, getUnsupportedExceptionForOperation, isLinkedToTable, modulus, multiply, negate, remove, subtract, toString`

### Methods inherited from class org.h2.value.VersionedValue

`getCommittedValue, getCurrentValue, getOperationId, isCommitted`

### Methods inherited from class java.lang.Object

`clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

### Method Detail

#### get

    public static ValueArray get(Value[] list)

Get or create a array value for the given value array. Do not clone the data.

Parameters:
  `list` - the value array
Returns:
  the value

#### get

    public static ValueArray get(java.lang.Class<?> componentType,
                 Value[] list)

Get or create a array value for the given value array. Do not clone the data.

Parameters:
  `componentType` - the array class (null for Object[])
  `list` - the value array
Returns:
  the value

#### getEmpty

    public static ValueArray getEmpty()

Returns empty array.

Returns:
  empty array

#### getValueType

    public int getValueType()

Description copied from class: `Value`
Get the value type.

Specified by:
  `getValueType` in class `Value`
Returns:
  the value type

#### getComponentType

    public java.lang.Class<?> getComponentType()

#### getString

    public java.lang.String getString()

Description copied from class: `Value`
Get the value as a string.

Specified by:
  `getString` in class `Value`
Returns:
  the string

#### compareTypeSafe

    public int compareTypeSafe(Value o,
                      CompareMode mode)

Description copied from class: `Value`
Compare this value against another value given that the values are of the same data type.

Specified by:
  `compareTypeSafe` in class `Value`
Parameters:
  `o` - the other value
  `mode` - the compare mode
Returns:
  0 if both values are equal, -1 if the other value is smaller, and 1 otherwise

#### getObject

    public java.lang.Object getObject()

Description copied from class: `Value`
Get the value as an object.

Specified by:
  `getObject` in class `Value`
Returns:
  the object

#### set

    public void set(java.sql.PreparedStatement prep,
           int parameterIndex)
             throws java.sql.SQLException

Description copied from class: `Value`
Set the value as a parameter in a prepared statement.

Specified by:
  `set` in class `Value`
Parameters:
  `prep` - the prepared statement
  `parameterIndex` - the parameter index
Throws:
  `java.sql.SQLException`

#### getSQL

    public java.lang.StringBuilder getSQL(java.lang.StringBuilder builder)

Description copied from class: `Value`
Appends the SQL expression for this value to the specified builder.

Specified by:
  `getSQL` in class `Value`
Parameters:
  `builder` - string builder
Returns:
  the specified string builder

#### getTraceSQL

    public java.lang.String getTraceSQL()

Description copied from class: `Value`
Get a medium size SQL expression for debugging or tracing. If the precision is too large, only a subset of the value is returned.

Overrides:
  `getTraceSQL` in class `Value`
Returns:
  the SQL expression

#### equals

    public boolean equals(java.lang.Object other)

Description copied from class: `Value`
Check if the two values have the same hash code. No data conversion is made; this method returns false if the other object is not of the same class. For some values, compareTo may return 0 even if equals return false. Example: ValueDecimal 0.0 and 0.00.

Specified by:
  `equals` in class `Value`
Parameters:
  `other` - the other value
Returns:
  true if they are equal

#### convertPrecision

    public Value convertPrecision(long precision,
                         boolean force)

Description copied from class: `Value`
Convert the precision to the requested value. The precision of the returned value may be somewhat larger than requested, because values with a fixed precision are not truncated.

Overrides:
  `convertPrecision` in class `Value`
Parameters:
  `precision` - the new precision
  `force` - true if losing numeric precision is allowed
Returns:
  the new value